<template>
  <div class="gpa-notification" :class="componentCSS">
    <rui-icon class="gpa-notification__icon" :name="icon" size="3" />
    <div class="gpa-notification__content">
      <div class="gpa-notification__header">
        <rui-badge v-if="mapId" icon="map" :caption="mapName" size="small" />
        <div class="gpa-notification__header__date">{{ $d(createdAt, 'date') }}</div>
        <div class="gpa-notification__header__actions">
          <rui-toolbar v-if="archivable || deletable">
            <rui-button v-if="archivable"
                        icon="archive"
                        :title="$t('js.notifications.action.archive')"
                        :disabled="disableActions || !!archivedAt"
                        size="small"
                        @click="archive" />
            <rui-button v-if="deletable"
                        icon="trash"
                        :title="$t('js.notifications.action.delete')"
                        :disabled="disableActions"
                        variant="destructive"
                        size="small"
                        @click="destroy" />
          </rui-toolbar>
        </div>
      </div>
      <h3 class="gpa-notification__title">
        <!-- @slot Overrides the `title` prop -->
        <slot name="title">{{ title }}</slot>
      </h3>
      <div class="gpa-notification__body">
        <!-- @slot Notification content -->
        <slot />
      </div>
    </div>
  </div>
</template>

<script>
import RuiBadge from '@experiments-labs/rise_ui/src/components/Badge/Badge.vue'
import RuiButton from '@experiments-labs/rise_ui/src/components/Button/Button.vue'
import RuiIcon from '@experiments-labs/rise_ui/src/components/Icon/Icon.vue'
import RuiToolbar from '@experiments-labs/rise_ui/src/components/Toolbar/Toolbar.vue'

export default {
  name: 'GpaNotification',
  components: { RuiBadge, RuiButton, RuiToolbar, RuiIcon },
  props: {
    notificationId: { required: true, type: Number },
    icon: { required: true, type: String },
    title: { required: false, type: String, default: null },
    mapId: { required: false, type: Number, default: null },
    mapName: { required: false, type: String, default: null },
    createdAt: { required: true, type: Date },
    archivedAt: { required: false, type: Date, default: null },
    archivable: { required: false, type: Boolean, default: true },
    deletable: { required: false, type: Boolean, default: true },
    loading: { required: false, type: Boolean, default: false },
  },
  data () {
    return {
      internalLoading: false,
    }
  },
  computed: {
    componentCSS () {
      return [
        this.$props.archivedAt && 'gpa-notification--archived',
      ]
    },
    disableActions () {
      return this.$props.loading || this.internalLoading
    },
  },
  methods: {
    archive () {
      return this.$store.dispatch('archiveNotification', this.$props.notificationId)
    },
    destroy () {
      return this.$store.dispatch('destroyNotification', this.$props.notificationId)
    },
  },
}
</script>

<style lang="scss" src="./Notification.scss" />
